<?php
//------------------------------------------------------------------------------
//--                                                                          --
//--    FILE NAME :  NeoMailer.class.php                                      --
//--                                                                          --
//--        Designed by NeoJapan   2005-11-27   Ver. 1.00                     --
//--        Coded    by NeoJapan   2005-11-27   Ver. 1.00                     --
//--        Revised  by XXXXXXXXX  XXXX-XX-XX   Ver. X.00                     --
//--                                                                          --
//------------------------------------------------------------------------------
//--   (C)COPYRIGHT 2005 BY NeoJapan CORPORATION ALL RIGHTS RESERVED          --
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// 󥯥롼
//------------------------------------------------------------------------------
require_once('phpmailer' . DIRECTORY_SEPARATOR . 'class.phpmailer.php');

//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------
define('JIS_ESC_START', "\x1B".'$B');
define('JIS_ESC_END'  , "\x1B(B");
//------------------------------------------------------------------------------
// 饹
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//--    饹 NeoMailer                                                    --
//--    Class  NeoMailer                                                    --
//------------------------------------------------------------------------------
//--  MODIFIED        YYYY-MM-DD REV    - NOTES                               --
//--  NEOJAPAN        2005-11-27 1.00   - CREATE NEW                          --
//------------------------------------------------------------------------------
/**
 *
 *      :
 *      : php4.3.0ʹ
 */
class NeoMailer extends PHPMailer
{
    /**
     * phpץǰʸ
     * @var string
     */
    var $ScriptCharset = "";

    //--------------------------------------------------------------------------
    // 󥹥󥹥᥽å
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    //--    ؿ̾ ᡼                                               --
    //--    Method MailSend()                                               --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2005-11-27 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     * PHP mail()ؿǥ᡼򤹤롣
     *
     * @access private
     * @param  string  $header [IN]:᡼إå
     * @param  string  $body   [IN]:᡼ʸ
     * @return bool    trueǤʤfalse
     */
    function MailSend($header, $body)
    {
        $to_list = array();

        // To򤽤줾쥨󥳡
        for($i = 0; $i < count($this->to); $i++)
        {
            $to_list[] = $this->AddrFormat($this->to[$i]);
        }
        // ToϢ
        $to = implode(',', $to_list);

        // ʲƥ饹Ʊ
        if ($this->Sender != "" && strlen(ini_get("safe_mode"))< 1)
        {
            $old_from = ini_get("sendmail_from");
            ini_set("sendmail_from", $this->Sender);
            $params = sprintf("-oi -f %s", $this->Sender);
            $rt = @mail($to, $this->EncodeHeader($this->Subject), $body,
                        $header, $params);
        }
        else
        {
            $rt = @mail($to, $this->EncodeHeader($this->Subject), $body, $header);
        }

        if (isset($old_from))
            ini_set("sendmail_from", $old_from);

        if(!$rt)
        {
            $this->SetError($this->Lang("instantiate"));
            return false;
        }

        return true;
    }

    //--------------------------------------------------------------------------
    //--    ؿ̾ ʸκ                                               --
    //--    Method CreateBody()                                             --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2005-11-27 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     * ʸ롣
     * ʸ(body)ΤߤʸѴ򤫤롣
     * @access private
     */
    function CreateBody() {
        $result = "";
        $body = $this->ConvertString($this->Body);

        $this->SetWordWrap();

        switch($this->message_type)
        {
            case "alt":
                $result .= $this->GetBoundary($this->boundary[1], "",
                                              "text/plain", "");
                $result .= $this->EncodeString($this->AltBody, $this->Encoding);
                $result .= $this->LE.$this->LE;
                $result .= $this->GetBoundary($this->boundary[1], "",
                                              "text/html", "");

                $result .= $this->EncodeString($body, $this->Encoding);
                $result .= $this->LE.$this->LE;

                $result .= $this->EndBoundary($this->boundary[1]);
                break;
            case "plain":
                $result .= $this->EncodeString($body, $this->Encoding);
                break;
            case "attachments":
                $result .= $this->GetBoundary($this->boundary[1], "", "", "");
                $result .= $this->EncodeString($body, $this->Encoding);
                $result .= $this->LE;

                $result .= $this->AttachAll();
                break;
            case "alt_attachments":
                $result .= sprintf("--%s%s", $this->boundary[1], $this->LE);
                $result .= sprintf("Content-Type: %s;%s" .
                                   "\tboundary=\"%s\"%s",
                                   "multipart/alternative", $this->LE,
                                   $this->boundary[2], $this->LE.$this->LE);

                // Create text body
                $result .= $this->GetBoundary($this->boundary[2], "",
                                              "text/plain", "") . $this->LE;

                $result .= $this->EncodeString($this->AltBody, $this->Encoding);
                $result .= $this->LE.$this->LE;

                // Create the HTML body
                $result .= $this->GetBoundary($this->boundary[2], "",
                                              "text/html", "") . $this->LE;

                $result .= $this->EncodeString($body, $this->Encoding);
                $result .= $this->LE.$this->LE;

                $result .= $this->EndBoundary($this->boundary[2]);

                $result .= $this->AttachAll();
                break;
        }
        if($this->IsError())
            $result = "";

        return $result;
    }

    //--------------------------------------------------------------------------
    //--    ؿ̾ إåѥ󥳡ɽ                                   --
    //--    Method EncodeHeader()                                           --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2005-07-11 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     *
     * Encode a header string to best of Q, B, quoted or none.
     * @access private
     * @return string
     */
    function EncodeHeader ($str, $position = 'text')
    {
        $x = 0;

        $str = $this->ConvertString($str);

        switch (strtolower($position))
        {
            case 'phrase':
                // 򥨥󥳡ɤ硢ե٥åȡʳʸο롣
                $x = preg_match_all('/[^A-Za-z0-9_.\-]/', $str, $matches);
                break;
            case 'comment':
                $x = preg_match_all('/[()"]/', $str, $matches);
                // Fall-through
            case 'text':
            default:
                // ʸϤ򥨥󥳡ɤ硢ե٥åȡʳʸο롣
                $x += preg_match_all('/[\000-\010\013\014\016-\037\177-\377]/', $str, $matches);
                break;
        }

        // ѴʸʤȤѴʤ
        if ($x == 0)
        {
            return ($str);
        }

        //[ JISʤƬΥפɲ ]
        if (strcasecmp($this->CharSet, 'ISO-2022-JP' == 0))
        {
            return $this->rm_jis_b_mime_header($str, $this->LE);
        }

        // B󥳡
        $maxlen = 75 - 7 - strlen($this->CharSet);
        $maxlen = ((int) ($maxlen / 4)) * 3;
        $encoding = 'B';
        $chunked = trim($this->bm_chunk_split($str, $maxlen, "\n"));
        $encoded = base64_encode($chunked);

        $encoded = preg_replace('/^(.*)$/m', " =?".$this->CharSet."?$encoding?\\1?=", $encoded);
        $encoded = trim(str_replace("\n", $this->LE, $encoded));

        return $encoded;
    }

    //--------------------------------------------------------------------------
    //--    ؿ̾ ʸѴ                                           --
    //--    Method ConvertString()                                          --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2005-11-27 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     * ʸɤѴ롣
     *
     * @access private
     * @param  string  $str        [IN]:Ѵʸ
     * @return string  Ѵʸ
     */
    function ConvertString($str)
    {
        // ꤵ줿ʸɤǥ󥳡
        if (function_exists('mb_convert_encoding') && $this->ScriptCharset)
        {
            $str = mb_convert_encoding($str, $this->CharSet, $this->ScriptCharset);
        }
        // 󥳡ɤǥ󥳡
        else if (function_exists('mb_convert_encoding'))
        {
            $str = mb_convert_encoding($str, $this->CharSet);
        }

        return $str;
    }

    //--------------------------------------------------------------------------
    //--    ؿ̾ ʸɤѴ                                     --
    //--    Method rm_jis_b_mime_header()                                   --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2005-11-27 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     * ʸɤѴ롣
     *
     * @access private
     * @param  string  $str        [IN]:Ѵʸ
     * @return string  Ѵʸ
     */
    function rm_jis_b_mime_header($str, $ending = "\r\n")
    {
        $cnt        = 0;    // ʸ
        $chunklen   = 30;   // ʸĹ
        $encoded    = "";   // Ѵʸ

        //[ ƼޤꤿߤˤĤƷ֤ ]
        while(strlen($str) > 0 && $str != JIS_ESC_START && $cnt < 100)
        {
            $is_ascii = true; $cnt++;
            $second_byte = false;
            $len = min($chunklen, strlen($str)) - strlen(JIS_ESC_END) + 1;

            //[ ʸ(JIS_END-1)ʸĤõ ]
            for ($i = 0;$i<$len;$i++)
            {
                //[ JISΥץɤʤasciiasciiڤؤ롣 ]
                if ($str{$i} == "\x1B")
                {
                    $is_ascii = !$is_ascii;
                    $second_byte = false;
                }
                //[ ޥХȤʤ1ʸܤ2ʸܤ󤭤꤫ ]
                else if (!$is_ascii)
                {
                    $second_byte = !$second_byte;
                }
            }

            //[ ޤꤿߤasciiǽäƤ硢Ĺڤ ]
            if ($is_ascii)
            {
                //[ Ǹ夫2ʸܤasciiʤԤɵ ]
                if ($str{$i} != "\x1B")
                {
                    $len++;
                    //[ Ǹ夫1ʸܤasciiʤԤɵ ]
                    if ($str{$i+1} != "\x1B")
                    {
                        $len++;
                    }
                }

                $chunked = substr($str, 0, $len);
                $str = substr($str, $len);
            }
            //[ Ǹ3ʸascii->asciiΥפȽŤʤäƤ硢ޤڤ롣 ]
            else if (strpos(substr($str, $len-3),JIS_ESC_START) !== false)
            {
                $len = strrpos($str, JIS_ESC_START);
                $chunked = substr($str, 0, $len);
                $str = substr($str, $len);
            }
            //[ ޤꤿߤascii1ʸܤǽäƤ硢Ĺ-1ڤꡢESCɲä ]
            else if ($second_byte)
            {
                $len = min($chunklen-strlen(JIS_ESC_END), strlen($str));
                $chunked = substr($str, 0, $len);
                if (substr($chunked, -strlen(JIS_ESC_END)) != JIS_ESC_END)
                {
                    $chunked .= JIS_ESC_END;
                }
                $str = JIS_ESC_START.substr($str, $len);
            }
            //[ ޤꤿߤascii2ʸܤǽäƤ硢Ĺ-2ڤꡢESCɲä ]
            else
            {
                $len = min($chunklen-strlen(JIS_ESC_END)-1, strlen($str));
                $chunked = substr($str, 0, $len);
                if (substr($chunked, -strlen(JIS_ESC_END)) != JIS_ESC_END)
                {
                    $chunked .= JIS_ESC_END;
                }
                $str = JIS_ESC_START.substr($str, $len);
            }

            // ܰʹߤξ硢ʸɲä
            //ʺǽԤιˤϲԤĤʤإå˲Ԥդ١
            if( !empty($encoded) ){
                $encoded .= $ending;
            }
            $encoded .= " =?ISO-2022-JP?B?".base64_encode($chunked)."?=";
        }

        return $encoded;
    }
}
?>